## aoflagger 3.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(AOFlagger)

include(CTest)
include(ExternalProject)
include(CMakeVersionInfo.txt)
set(AOFLAGGER_VERSION
    "${AOFLAGGER_VERSION_MAJOR}.${AOFLAGGER_VERSION_MINOR}.${AOFLAGGER_VERSION_SUBMINOR}"
)

# Some CMake 'find package' files are stored in this directory
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

find_package(PkgConfig)
pkg_check_modules(SIGCXX sigc++-2.0)

option(ENABLE_GUI "Build rfigui and aoqplot tools" ON)
if(ENABLE_GUI)
  pkg_check_modules(GTKMM gtkmm-3.0>=3.0.0)
  if(GTKMM_FOUND)
    add_definitions(-DHAVE_GTKMM)
  else()
    message(
      WARNING
        "The graphical user interface library GTKMM was not found; rfigui and aoqplot will not be compiled."
    )
  endif(GTKMM_FOUND)
endif()

# Find and include git submodules
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
  # Update submodules as needed
  option(GIT_SUBMODULE "Check submodules during build" ON)
  if(GIT_SUBMODULE)
    message(STATUS "Submodule update")
    execute_process(
      COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive --checkout
              --depth 1
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      RESULT_VARIABLE GIT_SUBMOD_RESULT)
    if(NOT GIT_SUBMOD_RESULT EQUAL "0")
      message(
        FATAL_ERROR
          "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules"
      )
    endif()
  endif()
endif()

# Python needs to be found before pybind11 to avoid finding different versions
# of python
find_package(
  Python
  COMPONENTS Interpreter Development
  REQUIRED)
message(STATUS "Using python version ${Python_VERSION}")
include_directories(SYSTEM ${Python_INCLUDE_DIRS})

list(APPEND ExternalSubmoduleDirectories aocommon pybind11)
foreach(ExternalSubmodule IN LISTS ExternalSubmoduleDirectories)
  if(NOT EXISTS ${CMAKE_SOURCE_DIR}/external/${ExternalSubmodule})
    message(
      FATAL_ERROR
        "The external submodule '${ExternalSubmodule}' is missing in the external/ subdirectory. "
        "This is likely the result of downloading a git tarball without submodules. "
        "This is not supported: git tarballs do not provide the required versioning "
        "information for the submodules. Please perform a git clone of this repository."
    )
  endif()
endforeach()

# Include aocommon/pybind11 headers
include_directories("${CMAKE_SOURCE_DIR}/external/aocommon/include")
add_subdirectory("${CMAKE_SOURCE_DIR}/external/pybind11")
include_directories(SYSTEM ${pybind11_INCLUDE_DIR})

find_package(
  HDF5
  COMPONENTS C CXX
  REQUIRED)
add_definitions(${HDF5_DEFINITIONS})
include_directories(SYSTEM ${HDF5_INCLUDE_DIR})

set(CASACORE_MAKE_REQUIRED_EXTERNALS_OPTIONAL TRUE)
find_package(Casacore REQUIRED COMPONENTS casa ms tables measures)
include_directories(SYSTEM ${CASACORE_INCLUDE_DIRS})

find_package(CFITSIO REQUIRED)
include_directories(SYSTEM ${CFITSIO_INCLUDE_DIR})

find_path(
  FFTW3_INCLUDE_DIR
  NAMES fftw3.h
  HINTS ENV FFTW3_INCLUDE)

find_library(GSL_LIB NAMES gsl)
find_library(GSL_CBLAS_LIB NAMES gslcblas)
find_path(GSL_INCLUDE_DIR NAMES gsl/gsl_version.h)
if(GSL_INCLUDE_DIR)
  include_directories(SYSTEM ${GSL_INCLUDE_DIR})
endif(GSL_INCLUDE_DIR)

find_package(Threads REQUIRED)

find_package(PNG REQUIRED)

# boost::alignment requires Boost 1.56
find_package(Boost 1.56.0 REQUIRED COMPONENTS date_time system)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

find_library(FFTW3_LIB fftw3 REQUIRED HINTS ENV FFTW3_LIB)
include_directories(SYSTEM ${FFTW3_INCLUDE_DIR})

enable_language(Fortran OPTIONAL)
find_package(BLAS REQUIRED)
find_package(LAPACK REQUIRED)
find_package(Lua 5.3 REQUIRED)
include_directories(SYSTEM ${LUA_INCLUDE_DIR})

# The following stuff will set the "rpath" correctly, so that LD_LIBRARY_PATH
# doesn't have to be set.

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH FALSE)
# when building, don't use the install RPATH already (but later on when
# installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
# add the automatically determined parts of the RPATH which point to directories
# outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
# the RPATH to be used when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES
     "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif("${isSystemDir}" STREQUAL "-1")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)
add_compile_options(
  -DNDEBUG
  -O3
  -Wall
  -Wvla
  -Wzero-as-null-pointer-constant
  -Wnon-virtual-dtor
  -Wduplicated-branches
  -Wundef
  -Wvla
  -Wpointer-arith
  -Wextra
  -Wno-unused-parameter)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  # GCC 8.x requires linking with stdc++fs for the filesystem library
  # https://gcc.gnu.org/onlinedocs/gcc-9.1.0/libstdc++/manual/manual/status.html#status.iso.2017
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
    link_libraries(stdc++fs)
  elseif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
    message(
      FATAL_ERROR "The GCC version is too old, upgrade to GCC 8.0 or newer")
  endif()
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "Debug build selected: setting linking flag --no-undefined")
  string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--no-undefined")
endif()

include(CheckCXXCompilerFlag)
include(CheckSymbolExists)
include(CheckCXXSymbolExists)
include(CheckIncludeFileCXX)

check_symbol_exists(posix_fallocate "fcntl.h" HAVE_POSIX_FALLOCATE)
check_cxx_symbol_exists(exp10 "cmath" HAVE_EXP10)
if(HAVE_POSIX_FALLOCATE)
  add_definitions(-DHAVE_POSIX_FALLOCATE)
endif(HAVE_POSIX_FALLOCATE)

option(PORTABLE "Build portable binaries (with slightly decreased performance)"
       ON)
if(PORTABLE)
  message(
    STATUS
      "Portable build requested; a generic build will be created with slightly decreased performance."
  )
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
endif(PORTABLE)

if(GSL_LIB
   AND GSL_CBLAS_LIB
   AND GSL_INCLUDE_DIR)
  add_definitions(-DHAVE_GSL)
  link_libraries(${GSL_LIB} ${GSL_CBLAS_LIB})
  message(STATUS "GSL found.")
endif(
  GSL_LIB
  AND GSL_CBLAS_LIB
  AND GSL_INCLUDE_DIR)

configure_file(version.h.in version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(AOQPLOT_FILES
    aoqplot/aoqplotwindow.cpp
    aoqplot/baselineplotpage.cpp
    aoqplot/datawindow.cpp
    aoqplot/grayscaleplotpage.cpp
    aoqplot/histogrampage.cpp
    aoqplot/timefrequencyplotpage.cpp
    aoqplot/twodimensionalplotpage.cpp
    aoqplot/controllers/aoqplotcontroller.cpp
    aoqplot/controllers/aoqplotpagecontroller.cpp
    aoqplot/controllers/baselinepagecontroller.cpp
    aoqplot/controllers/heatmappagecontroller.cpp
    aoqplot/controllers/histogrampagecontroller.cpp
    aoqplot/controllers/tfpagecontroller.cpp)

set(PLOT_FILES
    rfigui/maskedheatmap.cpp
    plot/colorscale.cpp
    plot/heatmap.cpp
    plot/horizontalplotscale.cpp
    plot/legend.cpp
    plot/plotbase.cpp
    plot/plotpropertieswindow.cpp
    plot/plotwidget.cpp
    plot/title.cpp
    plot/vectorimage.cpp
    plot/verticalplotscale.cpp
    plot/xyplot.cpp)

set(GUI_FILES
    rfigui/controllers/imagecomparisoncontroller.cpp
    rfigui/controllers/rfiguicontroller.cpp
    rfigui/gotowindow.cpp
    rfigui/imagepropertieswindow.cpp
    rfigui/opendialog.cpp
    rfigui/plotframe.cpp
    rfigui/plotwindow.cpp
    rfigui/progresswindow.cpp
    rfigui/rfiguimenu.cpp
    rfigui/rfiguiwindow.cpp
    rfigui/settings.cpp
    rfigui/simulatedialog.cpp
    rfigui/strategyeditor.cpp
    util/rfiplots.cpp
    util/multiplot.cpp
    ${PLOT_FILES}
    ${AOQPLOT_FILES})

set(IMAGING_FILES imaging/uvimager.cpp imaging/model.cpp)

set(INTERFACE_FILES
    interface/aoflagger.cpp interface/flagmask.cpp interface/imageset.cpp
    interface/qualitystatistics.cpp interface/strategy.cpp)

set(LUA_FILES
    lua/datawrapper.cpp
    lua/default-strategy.cpp
    lua/functions.cpp
    lua/functionswrapper.cpp
    lua/luastrategy.cpp
    lua/optionsfunction.cpp
    lua/scriptdata.cpp
    lua/telescopefile.cpp)

set(MSIO_FILES
    msio/baselinematrixloader.cpp
    msio/baselinereader.cpp
    msio/directbaselinereader.cpp
    msio/fitsfile.cpp
    msio/memorybaselinereader.cpp
    msio/msstatreader.cpp
    msio/pngfile.cpp
    msio/reorderingbaselinereader.cpp
    msio/rspreader.cpp
    msio/singlebaselinefile.cpp
    msio/spatialtimeloader.cpp)

set(STRUCTURES_FILES
    structures/image2d.cpp
    structures/mask2d.cpp
    structures/msiterator.cpp
    structures/msmetadata.cpp
    structures/samplerow.cpp
    structures/stokesimager.cpp
    structures/timefrequencydata.cpp)

set(QUALITY_FILES
    quality/collector.cpp
    quality/combine.cpp
    quality/histogramcollection.cpp
    quality/histogramtablesformatter.cpp
    quality/operations.cpp
    quality/qualitytablesformatter.cpp
    quality/rayleighfitter.cpp
    quality/statisticscollection.cpp)

set(ALGORITHMS_FILES
    algorithms/antennaselector.cpp
    algorithms/baselineselector.cpp
    algorithms/baselinetimeplaneimager.cpp
    algorithms/combinatorialthresholder.cpp
    algorithms/fringetestcreater.cpp
    algorithms/highpassfilter.cpp
    algorithms/morphology.cpp
    algorithms/sinusfitter.cpp
    algorithms/siroperator.cpp
    algorithms/morphologicalflagger.cpp
    algorithms/sumthreshold.cpp
    algorithms/sumthresholdmissing.cpp
    algorithms/svdmitigater.cpp
    algorithms/testsetgenerator.cpp
    algorithms/thresholdconfig.cpp
    algorithms/thresholdtools.cpp
    algorithms/timefrequencystatistics.cpp)

set(PYTHON_FILES python/pythonstrategy.cpp python/pyfunctions.cpp)

set(IMAGESETS_FILES
    imagesets/bhfitsimageset.cpp
    imagesets/filterbankset.cpp
    imagesets/fitsimageset.cpp
    imagesets/h5imageset.cpp
    imagesets/imageset.cpp
    imagesets/indexableset.cpp
    imagesets/msimageset.cpp
    imagesets/multibandmsimageset.cpp
    imagesets/parmimageset.cpp
    imagesets/pngreader.cpp
    imagesets/rfibaselineset.cpp
    imagesets/sdhdfimageset.cpp)

set(UTIL_FILES
    plot/colormap.cpp
    util/logger.cpp
    util/ffttools.cpp
    util/integerdomain.cpp
    util/plot.cpp
    util/rng.cpp
    util/stopwatch.cpp)

set(ALL_LIBRARIES
    ${CASACORE_LIBRARIES}
    ${FFTW3_LIB}
    ${CFITSIO_LIBRARY}
    ${Python_LIBRARIES}
    ${PNG_LIBRARIES}
    ${LUA_LIBRARIES}
    ${Boost_LIBRARIES}
    ${BLAS_LIBRARIES}
    ${LAPACK_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${HDF5_CXX_LIBRARIES}
    ${HDF5_C_LIBRARIES})

if(GTKMM_FOUND)
  message(STATUS "GTKMM found.")
  include_directories(SYSTEM ${GTKMM_INCLUDE_DIRS})
  link_directories(${GTKMM_LIBDIR})
  set(ALL_LIBRARIES ${ALL_LIBRARIES} ${GTKMM_LIBRARIES})
endif(GTKMM_FOUND)

if(SIGCXX_FOUND)
  message(STATUS "SIGCXX found.")
  include_directories(SYSTEM ${SIGCXX_INCLUDE_DIRS})
  link_directories(${SIGCXX_LIBDIR})
  set(ALL_LIBRARIES ${ALL_LIBRARIES} ${SIGCXX_LIBRARIES})
endif(SIGCXX_FOUND)

if(GTKMM_FOUND)
  set(AOFLAGGER_PLOT_FILES ${PLOT_FILES})
endif(GTKMM_FOUND)

set(ALL_NON_GUI_FILES
    ${ALGORITHMS_FILES}
    ${AOFLAGGER_PLOT_FILES}
    ${IMAGESETS_FILES}
    ${IMAGING_FILES}
    ${INTERFACE_FILES}
    ${LUA_FILES}
    ${MSIO_FILES}
    ${PYTHON_FILES}
    ${QUALITY_FILES}
    ${STRUCTURES_FILES}
    ${UTIL_FILES})
add_library(aoflagger-lib SHARED ${ALL_NON_GUI_FILES})
set_target_properties(aoflagger-lib PROPERTIES SOVERSION 0)
set_target_properties(aoflagger-lib PROPERTIES OUTPUT_NAME aoflagger)
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  # By default, CMAKE_LIBRARY_OUTPUT_DIRECTORY is not defined. -> Store
  # libaoflagger.so in lib/ and add the strategies in lib/aoflagger/strategies,
  # so libaoflagger can find them. Using the current directory is not possible,

=== cpack/CMakeLists.txt ===
# Copyright (C) 2020 A. R. Offringa. SPDX-License-Identifier: GPL-3.0-or-later

set(CPACK_PACKAGE_NAME "AOFlagger")
set(CPACK_PACKAGE_VENDOR "ASTRON")
set(CPACK_PACKAGE_VERSION_MAJOR "${AOFLAGGER_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${AOFLAGGER_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${AOFLAGGER_VERSION_SUBMINOR}")
set(CPACK_PACKAGE_VERSION
    "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}"
)
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY
    "Find RFI in radio astronomical observations")
set(CPACK_PACKAGE_HOMEPAGE_URL "https://gitlab.com/aroffringa/aoflagger/")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")

set(CPACK_GENERATOR "DEB")
set(CPACK_SOURCE_GENERATOR "TGZ")

set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "deb-packages@astron.nl")
set(CPACK_DEBIAN_PACKAGE_SECTION "science")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)

include(CPack)

=== python/CMakeLists.txt ===
pybind11_add_module(python_aoflagger MODULE pyinterface.cpp pyfunctions.cpp)

set_target_properties(python_aoflagger PROPERTIES SOVERSION 0)
set_target_properties(python_aoflagger PROPERTIES OUTPUT_NAME "aoflagger")
target_link_libraries(
  python_aoflagger
  PUBLIC aoflagger-lib
  PUBLIC ${ALL_LIBRARIES})
install(TARGETS python_aoflagger DESTINATION lib)

=== external/aocommon/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)

project(aocommon)

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-std=c++17" COMPILER_HAS_CXX17)

set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -Wall -Werror=zero-as-null-pointer-constant -ggdb")

if(COMPILER_HAS_CXX17 AND NOT DISABLE_CXX17)
  add_compile_options(-std=c++17)
  add_definitions(-DHAVE_LOGGER)
else()
  add_compile_options(-std=c++11)
  message(
    WARNING
      "Selected compiler does not support the C++17 standard. This will disable the Logger class, which requires C++17."
  )
endif()

# add target to generate API documentation with Doxygen
find_package(Threads REQUIRED)
find_package(Doxygen)

if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(
    doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen"
    VERBATIM)
endif(DOXYGEN_FOUND)

find_package(
  Boost
  COMPONENTS unit_test_framework date_time
  REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

# Casacore has a separate CMake file in this directory
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
set(CASACORE_MAKE_REQUIRED_EXTERNALS_OPTIONAL TRUE)
find_package(Casacore REQUIRED COMPONENTS casa ms tables measures fits)
include_directories(SYSTEM ${CASACORE_INCLUDE_DIRS})

find_package(CFITSIO REQUIRED)
include_directories(SYSTEM ${CFITSIO_INCLUDE_DIR})

add_executable(
  runtests
  tests/runtests.cpp
  tests/tangle.cpp
  tests/tbanddata.cpp
  tests/tbarrier.cpp
  tests/tfits.cpp
  tests/tfluxdensity.cpp
  tests/thmatrix4x4.cpp
  tests/timage.cpp
  tests/tlane.cpp
  tests/tlogger.cpp
  tests/tmatrix2x2.cpp
  tests/tmatrix2x2diag.cpp
  tests/tmatrix4x4.cpp
  tests/tmultibanddata.cpp
  tests/tparallelfor.cpp
  tests/tqueue.cpp
  tests/tradeccoord.cpp
  tests/tstaticfor.cpp
  tests/tserialstream.cpp
  tests/tthreadpool.cpp
  tests/tthrowruntimeerror.cpp
  tests/ttransform_if.cpp
  tests/tuvector.cpp)
target_link_libraries(
  runtests ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_DATE_TIME_LIBRARY}
  ${CMAKE_THREAD_LIBS_INIT} ${CASACORE_LIBRARIES} ${CFITSIO_LIBRARY})

add_custom_target(execute_runtests_target ALL DEPENDS execute_runtests)
add_custom_command(
  OUTPUT execute_runtests
  COMMAND runtests
  DEPENDS runtests)

add_custom_target(
  coverage
  COMMAND gcovr -r .. -e '.*/tests/.*' -e '.*/CompilerIdCXX/.*'
  COMMAND gcovr -r .. -e '.*/tests/.*' -e '.*/CompilerIdCXX/.*' --xml >
          coverage.xml
  DEPENDS execute_runtests)

message(STATUS "Flags passed to C++ compiler: " ${CMAKE_CXX_FLAGS})

=== external/pybind11/tests/CMakeLists.txt ===
# CMakeLists.txt -- Build system for the pybind11 test suite
#
# Copyright (c) 2015 Wenzel Jakob <wenzel@inf.ethz.ch>
#
# All rights reserved. Use of this source code is governed by a
# BSD-style license that can be found in the LICENSE file.

cmake_minimum_required(VERSION 3.4)

# The `cmake_minimum_required(VERSION 3.4...3.18)` syntax does not work with
# some versions of VS that have a patched CMake 3.11. This forces us to emulate
# the behavior using the following workaround:
if(${CMAKE_VERSION} VERSION_LESS 3.21)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else()
  cmake_policy(VERSION 3.21)
endif()

# Only needed for CMake < 3.5 support
include(CMakeParseArguments)

# Filter out items; print an optional message if any items filtered. This ignores extensions.
#
# Usage:
#   pybind11_filter_tests(LISTNAME file1.cpp file2.cpp ... MESSAGE "")
#
macro(pybind11_filter_tests LISTNAME)
  cmake_parse_arguments(ARG "" "MESSAGE" "" ${ARGN})
  set(PYBIND11_FILTER_TESTS_FOUND OFF)
  # Make a list of the test without any extensions, for easier filtering.
  set(_TMP_ACTUAL_LIST "${${LISTNAME}};") # enforce ';' at the end to allow matching last item.
  string(REGEX REPLACE "\\.[^.;]*;" ";" LIST_WITHOUT_EXTENSIONS "${_TMP_ACTUAL_LIST}")
  foreach(filename IN LISTS ARG_UNPARSED_ARGUMENTS)
    string(REGEX REPLACE "\\.[^.]*$" "" filename_no_ext ${filename})
    # Search in the list without extensions.
    list(FIND LIST_WITHOUT_EXTENSIONS ${filename_no_ext} _FILE_FOUND)
    if(_FILE_FOUND GREATER -1)
      list(REMOVE_AT ${LISTNAME} ${_FILE_FOUND}) # And remove from the list with extensions.
      list(REMOVE_AT LIST_WITHOUT_EXTENSIONS ${_FILE_FOUND}
      )# And our search list, to ensure it is in sync.
      set(PYBIND11_FILTER_TESTS_FOUND ON)
    endif()
  endforeach()
  if(PYBIND11_FILTER_TESTS_FOUND AND ARG_MESSAGE)
    message(STATUS "${ARG_MESSAGE}")
  endif()
endmacro()

macro(possibly_uninitialized)
  foreach(VARNAME ${ARGN})
    if(NOT DEFINED "${VARNAME}")
      set("${VARNAME}" "")
    endif()
  endforeach()
endmacro()

# Function to add additional targets if any of the provided tests are found.
# Needles; Specifies the test names to look for.
# Additions; Specifies the additional test targets to add when any of the needles are found.
macro(tests_extra_targets needles additions)
  # Add the index for this relation to the index extra targets map.
  list(LENGTH PYBIND11_TEST_EXTRA_TARGETS PYBIND11_TEST_EXTRA_TARGETS_LEN)
  list(APPEND PYBIND11_TEST_EXTRA_TARGETS ${PYBIND11_TEST_EXTRA_TARGETS_LEN})
  # Add the test names to look for, and the associated test target additions.
  set(PYBIND11_TEST_EXTRA_TARGETS_NEEDLES_${PYBIND11_TEST_EXTRA_TARGETS_LEN} ${needles})
  set(PYBIND11_TEST_EXTRA_TARGETS_ADDITION_${PYBIND11_TEST_EXTRA_TARGETS_LEN} ${additions})
endmacro()

# New Python support
if(DEFINED Python_EXECUTABLE)
  set(PYTHON_EXECUTABLE "${Python_EXECUTABLE}")
  set(PYTHON_VERSION "${Python_VERSION}")
endif()

# There's no harm in including a project in a project
project(pybind11_tests CXX)

# Access FindCatch and more
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../tools")

option(PYBIND11_WERROR "Report all warnings as errors" OFF)
option(DOWNLOAD_EIGEN "Download EIGEN (requires CMake 3.11+)" OFF)
option(PYBIND11_CUDA_TESTS "Enable building CUDA tests (requires CMake 3.12+)" OFF)
set(PYBIND11_TEST_OVERRIDE
    ""
    CACHE STRING "Tests from ;-separated list of *.cpp files will be built instead of all tests")
set(PYBIND11_TEST_FILTER
    ""
    CACHE STRING "Tests from ;-separated list of *.cpp files will be removed from all tests")

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  # We're being loaded directly, i.e. not via add_subdirectory, so make this
  # work as its own project and load the pybind11Config to get the tools we need
  find_package(pybind11 REQUIRED CONFIG)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT DEFINED CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting tests build type to MinSizeRel as none was specified")
  set(CMAKE_BUILD_TYPE
      MinSizeRel
      CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel"
                                               "RelWithDebInfo")
endif()

if(PYBIND11_CUDA_TESTS)
  enable_language(CUDA)
  if(DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CUDA_STANDARD ${CMAKE_CXX_STANDARD})
  endif()
  set(CMAKE_CUDA_STANDARD_REQUIRED ON)
endif()

# Full set of test files (you can override these; see below, overrides ignore extension)
# Any test that has no extension is both .py and .cpp, so 'foo' will add 'foo.cpp' and 'foo.py'.
# Any test that has an extension is exclusively that and handled as such.
set(PYBIND11_TEST_FILES
    test_async
    test_buffers
    test_builtin_casters
    test_call_policies
    test_callbacks
    test_chrono
    test_class
    test_const_name
    test_constants_and_functions
    test_copy_move
    test_custom_type_casters
    test_custom_type_setup
    test_docstring_options
    test_eigen_matrix
    test_eigen_tensor
    test_enum
    test_eval
    test_exceptions
    test_factory_constructors
    test_gil_scoped
    test_iostream
    test_kwargs_and_defaults
    test_local_bindings
    test_methods_and_attributes
    test_modules
    test_multiple_inheritance
    test_numpy_array
    test_numpy_dtypes
    test_numpy_vectorize
    test_opaque_types
    test_operator_overloading
    test_pickling
    test_pytypes
    test_sequences_and_iterators
    test_smart_ptr
    test_stl
    test_stl_binders
    test_tagbased_polymorphic
    test_thread
    test_union
    test_virtual_functions)

# Invoking cmake with something like:
#     cmake -DPYBIND11_TEST_OVERRIDE="test_callbacks.cpp;test_pickling.cpp" ..
# lets you override the tests that get compiled and run.  You can restore to all tests with:
#     cmake -DPYBIND11_TEST_OVERRIDE= ..
if(PYBIND11_TEST_OVERRIDE)
  # Instead of doing a direct override here, we iterate over the overrides without extension and
  # match them against entries from the PYBIND11_TEST_FILES, anything that not matches goes into the filter list.
  string(REGEX REPLACE "\\.[^.;]*;" ";" TEST_OVERRIDE_NO_EXT "${PYBIND11_TEST_OVERRIDE};")
  string(REGEX REPLACE "\\.[^.;]*;" ";" TEST_FILES_NO_EXT "${PYBIND11_TEST_FILES};")
  # This allows the override to be done with extensions, preserving backwards compatibility.
  foreach(test_name ${TEST_FILES_NO_EXT})
    if(NOT ${test_name} IN_LIST TEST_OVERRIDE_NO_EXT
    )# If not in the allowlist, add to be filtered out.
      list(APPEND PYBIND11_TEST_FILTER ${test_name})
    endif()
  endforeach()
endif()

# You can also filter tests:
if(PYBIND11_TEST_FILTER)
  pybind11_filter_tests(PYBIND11_TEST_FILES ${PYBIND11_TEST_FILTER})
endif()

# Skip tests for CUDA check:
# /pybind11/tests/test_constants_and_functions.cpp(125):
#   error: incompatible exception specifications
if(PYBIND11_CUDA_TESTS)
  pybind11_filter_tests(
    PYBIND11_TEST_FILES test_constants_and_functions.cpp MESSAGE
    "Skipping test_constants_and_functions due to incompatible exception specifications")
endif()

# Now that the test filtering is complete, we need to split the list into the test for PYTEST
# and the list for the cpp targets.
set(PYBIND11_CPPTEST_FILES "")
set(PYBIND11_PYTEST_FILES "")

foreach(test_name ${PYBIND11_TEST_FILES})
  if(test_name MATCHES "\\.py$") # Ends in .py, purely python test.
    list(APPEND PYBIND11_PYTEST_FILES ${test_name})
  elseif(test_name MATCHES "\\.cpp$") # Ends in .cpp, purely cpp test.
    list(APPEND PYBIND11_CPPTEST_FILES ${test_name})
  elseif(NOT test_name MATCHES "\\.") # No extension specified, assume both, add extension.
    list(APPEND PYBIND11_PYTEST_FILES ${test_name}.py)
    list(APPEND PYBIND11_CPPTEST_FILES ${test_name}.cpp)
  else()
    message(WARNING "Unhanded test extension in test: ${test_name}")
  endif()
endforeach()
set(PYBIND11_TEST_FILES ${PYBIND11_CPPTEST_FILES})
list(SORT PYBIND11_PYTEST_FILES)

# Contains the set of test files that require pybind11_cross_module_tests to be
# built; if none of these are built (i.e. because TEST_OVERRIDE is used and
# doesn't include them) the second module doesn't get built.
tests_extra_targets("test_exceptions.py;test_local_bindings.py;test_stl.py;test_stl_binders.py"
                    "pybind11_cross_module_tests")

# And add additional targets for other tests.
tests_extra_targets("test_exceptions.py" "cross_module_interleaved_error_already_set")
tests_extra_targets("test_gil_scoped.py" "cross_module_gil_utils")

set(PYBIND11_EIGEN_REPO
    "https://gitlab.com/libeigen/eigen.git"
    CACHE STRING "Eigen repository to use for tests")
# Always use a hash for reconfigure speed and security reasons
# Include the version number for pretty printing (keep in sync)
set(PYBIND11_EIGEN_VERSION_AND_HASH
    "3.4.0;929bc0e191d0927b1735b9a1ddc0e8b77e3a25ec"
    CACHE STRING "Eigen version to use for tests, format: VERSION;HASH")

list(GET PYBIND11_EIGEN_VERSION_AND_HASH 0 PYBIND11_EIGEN_VERSION_STRING)
list(GET PYBIND11_EIGEN_VERSION_AND_HASH 1 PYBIND11_EIGEN_VERSION_HASH)

# Check if Eigen is available; if not, remove from PYBIND11_TEST_FILES (but
# keep it in PYBIND11_PYTEST_FILES, so that we get the "eigen is not installed"
# skip message).
list(FIND PYBIND11_TEST_FILES test_eigen_matrix.cpp PYBIND11_TEST_FILES_EIGEN_I)
if(PYBIND11_TEST_FILES_EIGEN_I EQUAL -1)
  list(FIND PYBIND11_TEST_FILES test_eigen_tensor.cpp PYBIND11_TEST_FILES_EIGEN_I)
endif()
if(PYBIND11_TEST_FILES_EIGEN_I GREATER -1)
  # Try loading via newer Eigen's Eigen3Config first (bypassing tools/FindEigen3.cmake).
  # Eigen 3.3.1+ exports a cmake 3.0+ target for handling dependency requirements, but also
  # produces a fatal error if loaded from a pre-3.0 cmake.
  if(DOWNLOAD_EIGEN)
    if(CMAKE_VERSION VERSION_LESS 3.11)
      message(FATAL_ERROR "CMake 3.11+ required when using DOWNLOAD_EIGEN")
    endif()

    include(FetchContent)
    FetchContent_Declare(
      eigen
      GIT_REPOSITORY "${PYBIND11_EIGEN_REPO}"
      GIT_TAG "${PYBIND11_EIGEN_VERSION_HASH}")

    FetchContent_GetProperties(eigen)
    if(NOT eigen_POPULATED)
      message(
        STATUS
          "Downloading Eigen ${PYBIND11_EIGEN_VERSION_STRING} (${PYBIND11_EIGEN_VERSION_HASH}) from ${PYBIND11_EIGEN_REPO}"
      )
      FetchContent_Populate(eigen)
    endif()

    set(EIGEN3_INCLUDE_DIR ${eigen_SOURCE_DIR})
    set(EIGEN3_FOUND TRUE)
    # When getting locally, the version is not visible from a superprojet,
    # so just force it.
    set(EIGEN3_VERSION "${PYBIND11_EIGEN_VERSION_STRING}")

  else()
    find_package(Eigen3 3.2.7 QUIET CONFIG)

    if(NOT EIGEN3_FOUND)
      # Couldn't load via target, so fall back to allowing module mode finding, which will pick up
      # tools/FindEigen3.cmake
      find_package(Eigen3 3.2.7 QUIET)
    endif()
  endif()

  if(EIGEN3_FOUND)
    if(NOT TARGET Eigen3::Eigen)
      add_library(Eigen3::Eigen IMPORTED INTERFACE)
      set_property(TARGET Eigen3::Eigen PROPERTY INTERFACE_INCLUDE_DIRECTORIES
                                                 "${EIGEN3_INCLUDE_DIR}")
    endif()

    # Eigen 3.3.1+ cmake sets EIGEN3_VERSION_STRING (and hard codes the version when installed
    # rather than looking it up in the cmake script); older versions, and the
    # tools/FindEigen3.cmake, set EIGEN3_VERSION instead.
    if(NOT EIGEN3_VERSION AND EIGEN3_VERSION_STRING)
      set(EIGEN3_VERSION ${EIGEN3_VERSION_STRING})
    endif()
    message(STATUS "Building tests with Eigen v${EIGEN3_VERSION}")

    if(NOT (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0))
      tests_extra_targets("test_eigen_tensor.py" "eigen_tensor_avoid_stl_array")
    endif()

  else()
    list(FIND PYBIND11_TEST_FILES test_eigen_matrix.cpp PYBIND11_TEST_FILES_EIGEN_I)
    if(PYBIND11_TEST_FILES_EIGEN_I GREATER -1)

=== external/pybind11/tests/test_cmake_build/installed_function/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(test_installed_module CXX)

# The `cmake_minimum_required(VERSION 3.4...3.18)` syntax does not work with
# some versions of VS that have a patched CMake 3.11. This forces us to emulate
# the behavior using the following workaround:
if(${CMAKE_VERSION} VERSION_LESS 3.18)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else()
  cmake_policy(VERSION 3.18)
endif()

project(test_installed_function CXX)

find_package(pybind11 CONFIG REQUIRED)
message(
  STATUS "Found pybind11 v${pybind11_VERSION} ${pybind11_VERSION_TYPE}: ${pybind11_INCLUDE_DIRS}")

pybind11_add_module(test_installed_function SHARED NO_EXTRAS ../main.cpp)
set_target_properties(test_installed_function PROPERTIES OUTPUT_NAME test_cmake_build)

if(DEFINED Python_EXECUTABLE)
  set(_Python_EXECUTABLE "${Python_EXECUTABLE}")
elseif(DEFINED PYTHON_EXECUTABLE)
  set(_Python_EXECUTABLE "${PYTHON_EXECUTABLE}")
else()
  message(FATAL_ERROR "No Python executable defined (should not be possible at this stage)")
endif()

add_custom_target(
  check_installed_function
  ${CMAKE_COMMAND}
  -E
  env
  PYTHONPATH=$<TARGET_FILE_DIR:test_installed_function>
  ${_Python_EXECUTABLE}
  ${PROJECT_SOURCE_DIR}/../test.py
  ${PROJECT_NAME}
  DEPENDS test_installed_function)

=== debian/changelog ===
aoflagger (3.4.0-2build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:39:07 +0000

aoflagger (3.4.0-2build3) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:52:00 +0000

aoflagger (3.4.0-2build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:01:57 +0000

aoflagger (3.4.0-2build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 20 Jan 2024 17:59:30 +0000

aoflagger (3.4.0-2) unstable; urgency=medium

  * Source-only re-upload

 -- Ole Streicher <olebole@debian.org>  Thu, 26 Oct 2023 08:56:22 +0200

aoflagger (3.4.0-1) unstable; urgency=medium

  * New upstream version 3.4.0
  * Rediff patches
  * Push Standards-Version to 4.6.2. No changes needed
  * Add new build dep hdf5
  * Build test target before test
  * Add Python package. Closes: #1051927

 -- Ole Streicher <olebole@debian.org>  Tue, 24 May 2022 14:19:20 +0200

=== debian/control ===
Source: aoflagger
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>,
           Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: casacore-dev,
               cmake,
               debhelper-compat (= 13),
               doxygen,
               gfortran,
               graphviz,
               libblas-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-test-dev,
               libcfitsio-dev,
               libfftw3-dev,
               libgtkmm-3.0-dev,
               libhdf5-dev,
               liblapack-dev,
               liblua5.3-dev,
               libpng-dev,
               libpython3-dev,
               libxml2-dev,
               pybind11-dev,
               python3-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
Homepage: https://sourceforge.net/projects/aoflagger/
Rules-Requires-Root: no

Package: aoflagger
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: aoflagger-dev
Description: Find RFI in radio astronomical observations
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 Besides the flagger, the software consists of tools to efficiently visualize
 data in different ways, such as plotting time-frequency diagrams and power
 spectra. It provides the programs aoflagger, rfigui, aoqplot, aoquality and
 more.

Package: libaoflagger0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Find RFI in radio astronomical observations (shared lib)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the shared library.

Package: aoflagger-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libaoflagger0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: aoflagger
Description: Find RFI in radio astronomical observations (development files)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the header file to compile own programs against
 the library.

Package: python3-aoflagger
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libaoflagger0 (= ${binary:Version}),
         python3,
         ${misc:Depends},
         ${pyton3:Depends},
         ${shlibs:Depends}
Recommends: aoflagger
Description: Find RFI in radio astronomical observations (Python package)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the Python 3 package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH_CPU),i386)
    export DEB_CXXFLAGS_MAINT_APPEND = -ffloat-store
endif

CMAKE_FLAGS += -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` -DPORTABLE=yes

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	#$(MAKE) -C obj-* runtests
	dh_auto_test
endif
